///home/berryj/link/bin/genMethods "-g" "-t" "AttributeBase*" "-I" "LINK/graph/Attribute.h" "-d" "graph" "-y" "display_attributeptr" "-m" "mark_attributeptr" "-w" "free_attributeptr" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/Attribute.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_attributeptr(SCM, SCM, int);
void mark_attributeptr(SCM);
void free_attributeptr(SCM);

typedef AttributeBase* _AttributeBase_;

#define _AttributeBase_DATA(x) ((AttributeBase**) (EXTDATA(x)))
#define _AttributeBase_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<AttributeBase* >::type))
#define _AttributeBase_ISNT_DATA(x) (!_AttributeBase_IS_DATA(x))

#define _AttributeBase_CXX_DATA(x) (*(AttributeBase**) (EXTDATA(VAL(x))))
#define _AttributeBase_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<AttributeBase* >::type))
#define _AttributeBase_CXX_ISNT_DATA(x) (!_AttributeBase_CXX_IS_DATA(x))


static SCM is_AttributeBase_(SCM i)
{
	if (_AttributeBase_CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init__AttributeBase_()
{
	Wrapper<_AttributeBase_>::type = STk_new_CXXwrapper_id(
			Wrapper<_AttributeBase_>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			display_attributeptr,
			(void (*)(SCM x))mark_attributeptr,
			(void (*)(SCM x))free_attributeptr);
	Tcl_InitHashTable(&Register<_AttributeBase_>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("AttributeBase?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_AttributeBase_);
	return UNDEFINED;
}

void genExtra_AttributeBase_Methods(void);

PRIMITIVE STk_init_methods__AttributeBase_()
{
	genExtra_AttributeBase_Methods();
	return UNDEFINED;
}
